<?php

// If this file is called directly, abort.
if (!defined('WPINC')) {
    wp_die();
}

class SDOP_SettingsPage
{

    /**
     * @return void
     */
    public static function display_admin_page()
    {
        if (isset($_POST['sdop-admin-save'])) {
            self::save_admin_page();
        }

        add_thickbox();

        $html = '<div class="wrap sssp-post-table sssp-block sssp-sdop" style="max-width: 1600px">';
        $html .= '<h1>' . esc_attr__('Seznam Recommender', SEZNAM_SDOP_SLUG) . '</h1>';
        $html .= '<div class="sssp-post-table">';

        if(isset($_POST['sdop-admin-save'])){
            $html .= '<div class="notice notice-success inline"><p>' . esc_attr__('Settings were successfully saved!', SEZNAM_SDOP_SLUG) . '</p></div>';
        }

        $html .= self::css_style();
        $html .= self::link_switch();

        $html .= '<div class="sssp-post-table-left">';

        $html .= '<form method="post" action="" class="sssp-form">';

        $html .= self::block_settings();
        $html .= self::block_first_box();
        $html .= self::block_other_boxes();
        $html .= self::block_why_seznam();
        $html .= self::save_box();

        $html .= '<div class="sssp-clear"></div>';

        $html .= '</form>';

        $html .= '</div>';// sssp-post-table-left


        $html .= '<div class="sssp-post-table-right">';

        $html .= self::block_help();

        $html .= '</div>';// sssp-post-table-right


        $html .= '</div>';// sssp-post-table
        $html .= '</div>';// wrap

        echo $html;
    }

    public static function display_admin_page_rss()
    {
        if (isset($_POST['sdop-admin-save'])) {
            self::save_admin_page();
        }

        add_thickbox();

        $html = '<div class="wrap sssp-post-table sssp-block sssp-sdop" style="max-width: 1600px">';
        $html .= '<h1>' . esc_attr__('Seznam Recommender', SEZNAM_SDOP_SLUG) . '</h1>';
        $html .= '<div class="sssp-post-table">';

        $html .= self::css_style();
        $html .= self::link_switch();

        $html .= '<div class="sssp-post-table-left">';

        $html .= '<form method="post" action="" class="sssp-form">';

        $html .= self::rss_settings();
        $html .= self::save_box();

        $html .= '<div class="sssp-clear"></div>';

        $html .= '</form>';

        $html .= '</div>';// sssp-post-table-left


        $html .= '<div class="sssp-post-table-right">';

        $html .= self::block_help_rss();

        $html .= '</div>';// sssp-post-table-right


        $html .= '</div>';// sssp-post-table
        $html .= '</div>';// wrap

        echo $html;
    }


    /**
     *
     */
    public static function save_admin_page()
    {
        if (current_user_can(SEZNAM_SDOP_CAPABILITY)) {
            $_SANITIZED_POST = filter_input_array(INPUT_POST, FILTER_SANITIZE_STRING);

            //Media representation contract checker
            if (isset($_POST['sdop-admin-save'])) {

                unset($_SANITIZED_POST['sdop-admin-save']);
                if(isset($_GET['page']) && $_GET['page'] == 'seznam-sdop-admin-rss') {
                    if (isset($_SANITIZED_POST['sdop-rss-settings'])) {
                        $_SANITIZED_POST['sdop-rss-settings'] = '1';
                    } else {
                        $_SANITIZED_POST['sdop-rss-settings'] = '0';
                    }
                }
                if(isset($_GET['page']) && $_GET['page'] == 'seznam-sdop-admin'){
                    if (isset($_SANITIZED_POST['sdop-newsfeed'])) {
                        $_SANITIZED_POST['sdop-newsfeed'] = '1';
                    } else {
                        $_SANITIZED_POST['sdop-newsfeed'] = '0';
                    }
                    foreach (range(0, 5) as $number) {
                        if (isset($_SANITIZED_POST['sdop-box-id-manually-'.$number.''])) {
                            $_SANITIZED_POST['sdop-box-id-manually-'.$number.''] = '1';
                        } else {
                            $_SANITIZED_POST['sdop-box-id-manually-'.$number.''] = '0';
                        }
                    }
                }
            }

            foreach ($_SANITIZED_POST as $post_key => $post_value) {
                update_option($post_key, $post_value, true);
            }
        }

    }

    /**
     * @return string
     */
    private static function block_settings()
    {
        require_once(SEZNAM_SDOP_PATH . 'includes/sdop_form-elements.php');

        $html = '<div class="sssp-settings-box">';
        $html .= '<div class="sssp-section-title"><h2>' . esc_attr__('Web settings', SEZNAM_SDOP_SLUG) . '</h2></div>';

        $html .= '<div class="sssp-width-50">';
        $html .= SDOP_FormElements::get_form_field([
            'type' => 'number',
            'name' => 'sdop-web-id',
            'label' => esc_attr__('Web ID', SEZNAM_SDOP_SLUG),
            'value' => get_option('sdop-web-id', ''),
            'min' => '1',
            'max' => '1000000',
            'step' => '1',
            'required' => 'required',
            'status' => '',
            'placeholder' => esc_attr__('Web ID', SEZNAM_SDOP_SLUG) . '...',
            'default' => '',
        ]);
        $html .= '</div>';

        $html .= '<div class="sssp-width-50">';
        $html .= '</div>';


        $html .= '<div class="sssp-width-100">';

        $html .= SDOP_FormElements::get_form_field([
            'type' => 'checkbox',
            'name' => 'sdop-newsfeed',
            'label' => esc_attr__('Show recommendation boxes only for visitors from the Seznam Newsfeed service. (Not recommended)', SEZNAM_SDOP_SLUG),
            'value' => get_option('sdop-newsfeed', '0'),
            'required' => '',
        ]);

        $html .= '</div>';


        $html .= '<div class="sssp-clear"></div>';

        $html .= '</div>';// sssp-settings-box

        return $html;
    }

    /**
     * @return string
     */
    private static function block_first_box()
    {
        require_once(SEZNAM_SDOP_PATH . 'includes/sdop_form-elements.php');

        $html = '<div class="sssp-settings-box">';
        $html .= '<div class="sssp-section-title"><h2>' . esc_attr__('1st box', SEZNAM_SDOP_SLUG) . '</h2></div>';
        $html .= '<div class="sssp-section-subtitle"><h4>' . esc_attr__('Below the article', SEZNAM_SDOP_SLUG) . '</h4></div>';

        $html .= self::get_box(1, esc_attr__('1st box ID', SEZNAM_SDOP_SLUG), '');


        $html .= '<div class="sssp-clear"></div>';

        $html .= '</div>';// sssp-settings-box

        return $html;
    }


    /**
     * @return string
     */
    private static function block_other_boxes()
    {
        require_once(SEZNAM_SDOP_PATH . 'includes/sdop_form-elements.php');

        $html = '<div class="sssp-settings-box">';
        $html .= '<div class="sssp-section-title"><h2>' . esc_attr__('Other boxes', SEZNAM_SDOP_SLUG) . '</h2></div>';
        $html .= '<div class="sssp-section-subtitle"><h4>' . esc_attr__('Below the article', SEZNAM_SDOP_SLUG) . '</h4></div>';
        $html .= '<p>' . esc_attr__('Each box below the post might display a different type of content (personalized, most read, etc.). Contact the Seznam Recommender team (seznam.doporucuje@firma.seznam.cz) and they will do further setup for the boxes.', SEZNAM_SDOP_SLUG) . '</p>';

        $html .= self::get_box(2, esc_attr__('2nd box ID', SEZNAM_SDOP_SLUG));

        $html .= self::get_box(3, esc_attr__('3rd box ID', SEZNAM_SDOP_SLUG));

        $html .= '<div class="sssp-section-subtitle"><h4>' . esc_attr__('Sidebar', SEZNAM_SDOP_SLUG) . '</h4></div>';
        $html .= '<p>' . esc_attr__('Each box in the sidebar displays a different type of content (personalized, most read, etc.)', SEZNAM_SDOP_SLUG) . '</p>';

        $html .= self::get_box(4, esc_attr__('1st box ID', SEZNAM_SDOP_SLUG));
        $html .= self::get_box(5, esc_attr__('2nd box ID', SEZNAM_SDOP_SLUG));

        $html .= '<div class="sssp-clear"></div>';

        $html .= '</div>';// sssp-settings-box

        return $html;
    }

    /**
     * @param $post
     * @param $post_id
     * @return string
     */
    private static function box_insert($box_id)
    {

        $box_ID = get_option('sdop-box-id-' . $box_id, '');

        $html = '<div id="tabs-' . $box_id . '">';
        $html .= '<ul>';
        $html .= '<li><a href="#tabs-' . $box_id . '-1">' . esc_attr__('Shortcode', SEZNAM_SDOP_SLUG) . '</a></li>';
        $html .= '<li><a href="#tabs-' . $box_id . '-2">' . esc_attr__('PHP', SEZNAM_SDOP_SLUG) . '</a></li>';
        $html .= '<li><a href="#tabs-' . $box_id . '-3">' . esc_attr__('HTML', SEZNAM_SDOP_SLUG) . '</a></li>';
        $html .= '</ul>';
        $html .= '<div id="tabs-' . $box_id . '-1">';
        $html .= '<p>' . esc_attr__('You can use shortcode directly in the posts and most types of posts. Almost all page builders, WYSIWYG editors, and widgets support shortcodes. If your widget, editor, or page builder does not support shortcode use HTML code instead!', SEZNAM_SDOP_SLUG) . '</p>';
        $html .= '<textarea class="sssp-textarea-preview sssp-textarea-preview-shortcode-' . $box_id . '">[' . SEZNAM_SDOP_SLUG . ' id="' . $box_ID . '"]</textarea>';
        $html .= '<div class="sssp-width-100 sssp-form">';
        $html .= '<div class="sssp-form-button-box-2" data-target="shortcode-' . $box_id . '" style="margin: 0 0 15px 0">';
        $html .= SDOP_FormElements::get_form_field([
            'type' => 'submit',
            'name' => 'sssp-copy-code',
            'label' => esc_attr__('Copy code', SEZNAM_SDOP_SLUG),
        ]);
        $html .= '</div>';// sssp-form-button-box
        $html .= '</div>';
        $html .= '</div>';
        $html .= '<div id="tabs-' . $box_id . '-2">';
        $html .= '<p>' . esc_attr__('This type of insertion should be managed by advanced users only!', SEZNAM_SDOP_SLUG) . '</p>';
        $html .= '<textarea class="sssp-textarea-preview sssp-textarea-preview-php-' . $box_id . '">&#x3C;?php echo do_shortcode(&#x27;[' . SEZNAM_SDOP_SLUG . ' id="' . $box_ID . '"]&#x27;); ?&#x3E;</textarea>';
        $html .= '<div class="sssp-width-100 sssp-form">';
        $html .= '<div class="sssp-form-button-box-2" data-target="php-' . $box_id . '" style="margin: 0 0 15px 0">';
        $html .= SDOP_FormElements::get_form_field([
            'type' => 'submit',
            'name' => 'sssp-copy-code',
            'label' => esc_attr__('Copy code', SEZNAM_SDOP_SLUG),
        ]);
        $html .= '</div>';// sssp-form-button-box
        $html .= '</div>';
        $html .= '</div>';
        $html .= '<div id="tabs-' . $box_id . '-3">';
        $html .= '<p>' . esc_attr__('This type of insertion should be used only as of the last option. Shortcode and PHP method is better because all changes you will make will be automatically applied to the content. But not with the HTML insertion. After you do a change in the box settings, you must replace the old HTML code with the new one.', SEZNAM_SDOP_SLUG) . '</p>';
        $html .= '<textarea class="sssp-textarea-preview sssp-textarea-preview-html-' . $box_id . '"><div data-szn-recass-box=\'{"zone_id": ' . $box_ID . '}\'></div></textarea>';
        $html .= '<div class="sssp-width-100 sssp-form">';
        $html .= '<div class="sssp-form-button-box-2" data-target="html-' . $box_id . '" style="margin: 0 0 15px 0">';
        $html .= SDOP_FormElements::get_form_field([
            'type' => 'submit',
            'name' => 'sssp-copy-code',
            'label' => esc_attr__('Copy code', SEZNAM_SDOP_SLUG),
        ]);
        $html .= '</div>';// sssp-form-button-box
        $html .= '</div>';
        $html .= '</div>';
        $html .= '</div>';
        $html .= '<script>jQuery(document).ready(function($) {';
        $html .= '$(\'#tabs-' . $box_id . '\').tabs();})';
        $html .= '</script>';


        $html .= '<div class="sssp-clear"></div>';
        return $html;

    }

    /**
     * @return string
     */
    private static function block_why_seznam()
    {

        $html = '<div class="sssp-settings-box">';
        $html .= '<div class="sssp-section-title"><h2>' . esc_attr__('Why to use Seznam Recommendation box?', SEZNAM_SDOP_SLUG) . '</h2></div>';

        $html .= '<div class="sssp-width-100">';

        $html .= '<br><ul style="list-style: disc; padding-left:20px">';
        $html .= '<li>' . esc_attr__('10 - 30% increase in page views', SEZNAM_SDOP_SLUG) . '</li>';
        $html .= '<li>' . esc_attr__('around 20% higher advertisement yields', SEZNAM_SDOP_SLUG) . '</li>';
        $html .= '</ul>';
        $html .= '</div>';


        $html .= '<div class="sssp-clear"></div>';

        $html .= '</div>';// sssp-settings-box

        return $html;
    }


    /**
     * @return string
     */
    private static function save_box()
    {
        require_once(SEZNAM_SDOP_PATH . 'includes/sdop_form-elements.php');

        $html = '<div class="sssp-form-button-box" style="margin-bottom:20px;">';
        $html .= SDOP_FormElements::get_form_field([
            'type' => 'submit',
            'name' => 'sdop-admin-save',
            'label' => esc_attr__('Save settings', SEZNAM_SDOP_SLUG),
        ]);
        $html .= '</div>';

        $html .= '<div class="sssp-clear"></div>';

        return $html;
    }

    /**
     * @return string
     */
    private static function block_help()
    {
        $html = '<div class="sssp-settings-box">';
        $html .= '<div class="sssp-section-title"><h2>' . esc_attr__('Help', SEZNAM_SDOP_SLUG) . '</h2></div>';

        $html .= self::video_help();
        $html .= self::first_help();
        $html .= self::second_help();
        $html .= self::third_help();


        $html .= '</div>';// sssp-settings-box

        return $html;

    }

    /**
     * @return string
     */
    private static function video_help()
    {
        $html = '<h4>' . esc_attr__('Video tutorial', SEZNAM_SDOP_SLUG) . '</h4>';
        $format = html_entity_decode(sprintf(esc_html__('<a href=%s>Instructions for plugin usage</a>', SEZNAM_SDOP_SLUG), 'https://www.stream.cz/seznam-cz-reklama/seznam-doporucuje-navod-na-instalaci-a-nastaveni-pluginu-64342171'));
        $html .= $format;
        return $html;
    }

    /**
     * @return string
     */
    private static function first_help()
    {
        $html = '<br><br><h4>' . esc_attr__('Web ID', SEZNAM_SDOP_SLUG) . '</h4>';
        $format = html_entity_decode(esc_attr__('Insert web ID that will be provided to you via the Seznam Recommender team (seznam.doporucuje@firma.seznam.cz). Web ID is required.', SEZNAM_SDOP_SLUG));
        $html .= $format;
        return $html;
    }

    /**
     * @return string
     */
    private static function second_help()
    {
        $html = '<br><br><h4>' . esc_attr__('Boxes below the post', SEZNAM_SDOP_SLUG) . '</h4>';
        $format = html_entity_decode(esc_attr__('Insert box ID that will be provided to you via the Seznam Recommender team. This box ID is for the box below your post. Check "I want to insert the box manually" if you use a website builder that does not support automatic code insertion. If so, you need to insert the provided shortcode into the place where you want to have the recommender box.
Some website builders such as Elementor use automatic code insertion and you do not need to insert the shortcode manually.', SEZNAM_SDOP_SLUG));
        $html .= $format;
        return $html;
    }

    /**
     * @return string
     */
    private static function third_help()
    {
        $html = '<br><br><h4>' . esc_attr__('Boxes in the sidebar', SEZNAM_SDOP_SLUG) . '</h4>';
        $format = html_entity_decode(esc_attr__('Insert box ID that will be provided to you via the Seznam Recommender team. This box ID is for the box in the sidebar. Check "I want to insert the box manually" if you use a website builder that does not support widget insertion into the sidebar. If so, you need to insert the provided shortcode into the place where you want to have the recommender box.
Some website builders such as Elementor use automatic code insertion and you do not need to insert the shortcode manually.', SEZNAM_SDOP_SLUG));
        $html .= $format;
        return $html;
    }

    /**
     * @return string
     */
    private static function rss_help()
    {
        $html = '<h4>' . esc_attr__('Add categories into RSS', SEZNAM_SDOP_SLUG) . '</h4>';
        $format = html_entity_decode(esc_attr__('Check if you want to add wordpress categories into your RSS feed. This is needed if you want to show only articles restricted by category from the article which is currently read by an user. 
It is also needed to contact the Seznam Recommender team (seznam.doporucuje@firma.seznam.cz) to tell them which boxes will be restricted to wordpress categories.', SEZNAM_SDOP_SLUG));
        $html .= $format;
        return $html;
    }

    /**
     * @param $box_id
     * @return string
     */
    private static function get_box($box_id, $box_name, $required = '')
    {

        $html = '<div class="sssp-width-50 sdop-box-id-manually">';
        $html .= SDOP_FormElements::get_form_field([
            'type' => 'number',
            'name' => 'sdop-box-id-' . $box_id . '',
            'label' => esc_attr__($box_name, SEZNAM_SDOP_SLUG),
            'value' => get_option('sdop-box-id-' . $box_id . '', ''),
            'min' => '1',
            'max' => '1000000000',
            'step' => '1',
            'required' => $required,
            'status' => '',
            'placeholder' => esc_attr__($box_name . '.....', SEZNAM_SDOP_SLUG) . '...',
            'default' => '',
        ]);

        if ($box_id == 4 || $box_id == 5) {
            $box_number = ($box_id == 4) ? (1) : (2);
            $html .= '<p id="sssp-widget-description-box-' . $box_id . '" class="sssp-widget-description-box">' . html_entity_decode(sprintf(esc_html__('If you want to use sidebar box you must go to <a href=%s>Widget section</a> and select widget "Seznam Recommendation Widget %d" and move to the sidebar position', SEZNAM_SDOP_SLUG), SEZNAM_SDOP_ADMIN_URL . 'widgets.php', $box_number)) . '</p>';
        }

        $html .= '<div id="sssp-error-box-' . $box_id . '" style="color:red; display:none; margin-top:5px;">' . esc_attr__('You need to insert box ID first to be able to insert box manually.', SEZNAM_SDOP_SLUG) . '</div>';


        $html .= SDOP_FormElements::get_form_field([
            'type' => 'checkbox',
            'name' => 'sdop-box-id-manually-' . $box_id . '',
            'label' => esc_attr__('I want to insert the box manually', SEZNAM_SDOP_SLUG),
            'value' => get_option('sdop-box-id-manually-' . $box_id . '', '0'),
            'required' => '',
        ]);


        $html .= '<div id="manual-box-' . $box_id . '" style="margin-bottom:20px;">';

        $html .= self::box_insert($box_id);

        $html .= '</div>';

        $html .= '</div>'; //sssp-width-50


        $html .= '<div class="sssp-width-50 sssp-prev-image-box">';
        $html .= '<a class="thickbox" href="' . SEZNAM_SDOP_URL . '/assets/images/mockup-box' . $box_id . '.png"><img src="' . SEZNAM_SDOP_URL . '/assets/images/mockup-box' . $box_id . '-thumb.png" style="max-height:356px; max-width: 356px; width: 100%; margin-bottom: 20px; margin-top: 22px"></a>';
        $html .= '</div>';

        return $html;

    }

    /**
     * @return string
     */
    private static function rss_settings()
    {
        require_once(SEZNAM_SDOP_PATH . 'includes/sdop_form-elements.php');

        $html = '<div class="sssp-settings-box">';
        $html .= '<div class="sssp-section-title"><h2>' . esc_attr__('RSS settings', SEZNAM_SDOP_SLUG) . '</h2></div>';


        $html .= '<div class="sssp-width-100">';

        $html .= SDOP_FormElements::get_form_field([
            'type' => 'checkbox',
            'name' => 'sdop-rss-settings',
            'label' => esc_attr__('Add categories into RSS', SEZNAM_SDOP_SLUG),
            'value' => get_option('sdop-rss-settings', '1'),
            'required' => '',
        ]);

        $html .= '</div>';


        $html .= '<div class="sssp-clear"></div>';

        $html .= '</div>';// sssp-settings-box

        return $html;
    }

    /**
     * @return string
     */
    private static function block_help_rss()
    {
        $html = '<div class="sssp-settings-box">';
        $html .= '<div class="sssp-section-title"><h2>' . esc_attr__('Help', SEZNAM_SDOP_SLUG) . '</h2></div>';

        $html .= self::rss_help();


        $html .= '</div>';// sssp-settings-box

        return $html;

    }

    /**
     * @return string
     */
    private static function link_switch()
    {
        if (isset($_GET['page']) && $_GET['page'] == 'seznam-sdop-admin') {
            $active = 'sssp-rss-link-active';
            $active_rss = '';
        } else {
            $active = '';
            $active_rss = 'sssp-rss-link-active';
        }

        $html = '<div class="sssp-link-switch">';

        $html .= '<span class="' . $active . '"><a href="' . SEZNAM_SDOP_ADMIN_URL . '/tools.php?page=seznam-sdop-admin">' . esc_attr__('Web & Boxes', SEZNAM_SDOP_SLUG) . '</a></span>';
        $html .= '<span class="' . $active_rss . '"><a href="' . SEZNAM_SDOP_ADMIN_URL . '/tools.php?page=seznam-sdop-admin-rss">' . esc_attr__('RSS', SEZNAM_SDOP_SLUG) . '</a></span>';

        $html .= '</div>';// sssp-settings-box

        return $html;

    }

    private static function css_style(){
        return '<style>
                     .sssp-input-text::-webkit-input-placeholder { /* Edge */
                      color: grey;
                    }
                    h4{
                        margin-top:20px;
                    }
                    #sdop-admin-save{
                        cursor:pointer;
                    }
                    
                    .sssp-input-text:-ms-input-placeholder { /* Internet Explorer 10-11 */
                      color: grey;
                    }
                    
                    .sssp-input-text::placeholder {
                      color: grey;
                    }
                    </style>';
    }

}
